// XSDebugDlg.cpp : implementation file
//
// Justin Backman
// 2/12/1998

#include "stdafx.h"
#include "XSDebug.h"
#include "XSDebugDlg.h"
#include <stdlib.h>
#include <string.h>
#include <conio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Defined Constents
#define PPO 0x378
#define PPI 0x379
#define RXDAT 1
#define XCLK 2
#define RXSTB 4
#define TXSTB 8
#define TXDAT 8

// Public Variables
CString out0="00000000";
CString out1="00000000";
CString clk="11110";
CString sel="00";
CString xmitval=clk+sel+out1+out0;
// State that the clock is in
int ClkState=1;


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXSDebugDlg dialog

CXSDebugDlg::CXSDebugDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CXSDebugDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CXSDebugDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CXSDebugDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CXSDebugDlg)
	DDX_Control(pDX, IDC_SLIDER1, m_SetClk);
	DDX_Control(pDX, IDC_DSel3H, m_DSel3H);
	DDX_Control(pDX, IDC_DSel3, m_DSel3);
	DDX_Control(pDX, IDC_DSel2H, m_DSel2H);
	DDX_Control(pDX, IDC_DSel2, m_DSel2);
	DDX_Control(pDX, IDC_DSel1H, m_DSel1H);
	DDX_Control(pDX, IDC_DSel1, m_DSel1);
	DDX_Control(pDX, IDC_DSel0H, m_DSel0H);
	DDX_Control(pDX, IDC_DSel0, m_DSel0);
	DDX_Control(pDX, IDC_DinL, m_DinL);
	DDX_Control(pDX, IDC_DinLH, m_DinLH);
	DDX_Control(pDX, IDC_DispRun, m_DispRun);
	DDX_Control(pDX, IDC_DinHH, m_DinHH);
	DDX_Control(pDX, IDC_DinH, m_DinH);
	DDX_Control(pDX, IDC_BUTTON2, m_SingleStep);
	DDX_Control(pDX, IDC_BUTTON1, m_SetDin);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CXSDebugDlg, CDialog)
	//{{AFX_MSG_MAP(CXSDebugDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnSetDin)
	ON_BN_CLICKED(IDC_BUTTON2, OnSingleStep)
	ON_BN_CLICKED(IDC_RADIO1, OnClkHi)
	ON_BN_CLICKED(IDC_RADIO2, OnClkLow)
	ON_BN_CLICKED(IDC_RADIO3, OnClkRun)
	ON_BN_CLICKED(IDOK, OnClose)
	ON_BN_CLICKED(IDC_Reset, OnReset)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CXSDebugDlg message handlers

BOOL CXSDebugDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Sets the radio button to clock low
	CButton* pCheck = (CButton*)GetDlgItem(IDC_RADIO2);
	pCheck->SetCheck(1); 

	// Initializes the display values
	dlg->Refresh();
	m_DinH.SetWindowText("00000000");
	m_DinHH.SetWindowText(bin2hex("00000000"));
	m_DinH.LimitText(8);
	m_DinL.SetWindowText("00000000");
	m_DinL.LimitText(8);
	m_DinLH.SetWindowText(bin2hex("00000000"));
	m_DispRun.SetWindowText("12000000");
	m_DispRun.SetReadOnly();

	
	// Initializes the slider control
	m_SetClk.SetPos(0);
	m_SetClk.SetTicFreq(1);
	m_SetClk.SetRange(0,24,TRUE);
	
	// sets default button to set Din
	this->SetDefID(1012);   
	
	// Sets a timer to refresh the display every 1/2 second
	SetTimer(1234,500, &TimerProc);
	
	
	return FALSE;  // return TRUE  unless you set the focus to a control
}


void CALLBACK EXPORT TimerProc(HWND hWnd,UINT nMsg,UINT nIDEvent, DWORD dwTime )
{
	dlg->Refresh();
}

void CXSDebugDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CXSDebugDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CXSDebugDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CXSDebugDlg::OnSetDin() 
{
	CString temp1,temp2;
	m_DinH.GetWindowText(temp1);
	m_DinL.GetWindowText(temp2);
	if (temp1.GetLength()==8 && temp2.GetLength()==8)
	{
		out1=temp1;
		out0=temp2;
		m_DinHH.SetWindowText(bin2hex(temp1));
		m_DinLH.SetWindowText(bin2hex(temp2));
	}
	else
	{
		error("You must enter an 8 bit number!");
	}
	dlg->Refresh();
	
}

void CXSDebugDlg::OnSingleStep() 
{
	if (ClkState==1)
	{
		// Single Step by setting the clock high then low
		xmitval="1111100"+out1+out0;
		xmit(xmitval);
		xmitval="1111000"+out1+out0;
		xmit(xmitval);
		dlg->Refresh();
	}
	else
	{
		error("Single step not availible while clock is running.");
	}
}

void CXSDebugDlg::OnClkHi() 
{
	if (ClkState!=0)
	{
		clk="11111";
		dlg->Refresh();
	}
	ClkState=0;
}

void CXSDebugDlg::OnClkLow() 
{
	if (ClkState!=1)
	{
		clk="11110";
		dlg->Refresh();
	}
	ClkState=1;
}

void CXSDebugDlg::OnClkRun() 
{
	if (ClkState!=2)
	{
		CString temp="00000";
		int p=m_SetClk.GetPos();
		if (p>15) {temp.SetAt(0,'1');p=p-16;}
		if (p>7) {temp.SetAt(1,'1');p=p-8;}
		if (p>3) {temp.SetAt(2,'1');p=p-4;}
		if (p>1) {temp.SetAt(3,'1');p=p-3;}
		if (p>0) {temp.SetAt(4,'1');}
		clk=temp;
	}
	ClkState=2;
	dlg->Refresh();
}

void CXSDebugDlg::OnClose() 
{
	exit(0);
	
}
// Converts binary strings to hex strings
CString bin2hex(CString temp)
{
	char* blah=" ";
	CString temp2;
	int two=2;
	int t2;
	int mybyte=0;
	int j=temp.GetLength()-1;
	for (int i=0;i<temp.GetLength();i++)
	{
		if ( j==temp.GetLength()-1)
		{
			mybyte=(temp.GetAt(j)=='0')?0:1;
		}
		else 
		{
			t2=(temp.GetAt(j)=='0')?0:1;
			mybyte=mybyte+two*t2;
			two=two*2;
		}
		j=j-1;
	}
	_itoa(mybyte , blah, 16 );
	temp2=CString(blah);
	if (temp2.GetLength()==1){
		temp2='0'+temp2;
	}
	temp2.MakeUpper();
	return temp2;
}

// Transmits to the FPGA
void xmit(CString temp)
{
	int i=0;
	int bit=0;
	for (i=0;i<23;i++)
	{
		bit=(temp.GetAt(i)=='0')?0:RXDAT;
		_outp(PPO,bit);
		_outp(PPO,bit+XCLK);
		_outp(PPO,bit);
	}

	_outp(PPO,0);
	_outp(PPO,RXSTB);
	_outp(PPO,0);
}

// Recieves data from the FPGA
CString recv(void)
{
	CString temp= CString("00000000");
	int i,bit;
	for (i=0;i<8;i++)
	{
		if (i==0) 
		{
			_outp(PPO,TXSTB);
			_outp(PPO,TXSTB|XCLK);
			_outp(PPO,TXSTB);
		}
		else 
			_outp(PPO,XCLK);
		_outp(PPO,0);
		bit=_inp(PPI);
		temp.SetAt(i,(bit&TXDAT)?'1':'0');
	}
	return temp;
}
// Creates an error box
void error(CString temp)
{
	dlg->MessageBox( temp, "XDebug Error", MB_OK);
} 

// Refreshes the display
void CXSDebugDlg::Refresh() 
{
	CString temp;
	// Recieve Selection 0
	xmitval=clk+"00"+out1+out0;
	xmit(xmitval);
	temp=recv();
	m_DSel0.SetWindowText(temp);
	m_DSel0H.SetWindowText(bin2hex(temp));

	// Recieve Selection 1
	xmitval=clk+"01"+out1+out0;
	xmit(xmitval);
	temp=recv();
	m_DSel1.SetWindowText(temp);
	m_DSel1H.SetWindowText(bin2hex(temp));

	// Recieve Selection 2
	xmitval=clk+"10"+out1+out0;
	xmit(xmitval);
	temp=recv();
	m_DSel2.SetWindowText(temp);
	m_DSel2H.SetWindowText(bin2hex(temp));

	// Recieve Selection 3
	xmitval=clk+"11"+out1+out0;
	xmit(xmitval);
	temp=recv();
	m_DSel3.SetWindowText(temp);
	m_DSel3H.SetWindowText(bin2hex(temp));
}

// Reset button
void CXSDebugDlg::OnReset() 
{
	if (ClkState==1)
	{
	xmit(clk+"00"+"00000000"+"00000001");
	xmit(clk+"00"+"00000000"+"00000000");
	dlg->Refresh();
	}
	else
	{
		error("Reset not availible while clock is running");
	}
}

void CXSDebugDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	int t=12000000;
	char* blah2=" ";
	int p=m_SetClk.GetPos();
	for (int j=0;j<p;j++){
		t=t/2;
	}
	if (t!=0)
	{
		_itoa(t , blah2, 10);
		m_DispRun.SetWindowText(CString(blah2));	
	}
	else
	{
		m_DispRun.SetWindowText("<1");
	}
}

